Subject: Re: IPV6_RTHDR with a type-0 routing header

From: Shan Wei <[email-masked]>
Date: Fri, 21 Aug 2009 09:09:29 +0800

Steinar H. Gunderson wrote, at 08/20/2009 07:11 PM:
> Hi,
> 
> I've tried attaching a type-0 routing header to my IPv6 packets with
> setsockopt(..., IPV6_RTHDR, ...), but the kernel just returns EINVAL.
> looking at the source, it seems it simply refuses anything that's not type-2;
> should that really be right? I found the following commit:
> 
>   http://kerneltrap.org/mailarchive/linux-netdev/2008/11/11/4064594
> 
> However, it only seems to change EPERM into EINVAL. I don't see any

About the cause of changing EPERM into EINVAL, can refer to 
http://marc.info/?l=linux-netdev&m=122046709502496&w=3.

-- 
Best Regards
Shan Wei

> reasonable explanation why it should not be simply success; in fact, RFC 3452
> only seems to talk about using type-0 headers with this option.
> 
> Any ideas?
> 
> /* Steinar */